<?php
namespace Service\Queue\DownloadVersion;

use Doctrine\ORM\EntityManager;
use Util\Utilities;
use Zeedhi\Queue\Connection;

class Consumer extends \Zeedhi\Queue\Consumer{
    public $dir;
    protected static $queueName = "/queue/cp_download_version";
    /** @var EntityManager */
    protected $entityManager;

    /**
     * @param Connection $connection
     * @param EntityManager $entityManager
     */
    public function __construct(Connection $connection, EntityManager $entityManager)
    {
        parent::__construct($connection);
        $this->entityManager = $entityManager;
    }
    
    protected function log($message)
    {
        echo "[". (new \DateTime())->format('d/m/Y H:i:s') ."] ". $message, "\n";
    }
    
    public function consume($message)
    {
        try{
            $request  = json_decode($message, true);
            $threadId = $request['THREAD_ID'];

            $this->log("Message of the request: {$message}");
            set_time_limit(7200);
            $console = shell_exec("cd {$this->dir} && php downloadVersionScript.php {$threadId}");
            $this->log($console);
            $this->log('Request processed!');
            $this->log("------------------------\n\n");
        }catch (\Exception $ex){
            $this->log($ex->getMessage());
            $this->log("------------------------\n\n");
        }
    }
}